Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4724)
@@ -1371,37 +2013,64 @@
 !--    Note, this has no effect on the numeric solution, only for data output.
        IF ( bc_dirichlet_s )  v(nzt+1,nys,:) = v(nzt+1,nysv,:)
-
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             w(nzt,j,i) = interpolate_in_time( nest_offl%w_top(0,j,i),         &
-                                               nest_offl%w_top(1,j,i),         &
-                                               fac_dt ) *                      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_total_0(nzt,j,i), 3 ) )
-             w(nzt+1,j,i) = w(nzt,j,i)
-          ENDDO
-       ENDDO
-
-
-       IF ( .NOT. neutral )  THEN
+!
+!--    w-component
+       IF ( lod == 2 )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                pt(nzt+1,j,i) = interpolate_in_time( nest_offl%pt_top(0,j,i),  &
-                                                     nest_offl%pt_top(1,j,i),  &
-                                                     fac_dt )
-                pt_ref_l(nzt+1) = pt_ref_l(nzt+1) + pt(nzt+1,j,i)
+                w(nzt,j,i) = interpolate_in_time( nest_offl%w_top(0,j,i),                          &
+                                                  nest_offl%w_top(1,j,i),                          &
+                                                  fac_dt ) *                                       &
+                              MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(nzt,j,i), 3 ) )
+                w(nzt+1,j,i) = w(nzt,j,i)
              ENDDO
           ENDDO
-       ENDIF
-
+       ELSE
+          var_1d(nzt) = interpolate_in_time( nest_offl%w_top(0,1,1),                               &
+                                             nest_offl%w_top(1,1,1),                               &
+                                             fac_dt )
+          w(nzt,nys:nyn,nxl:nxr) = var_1d(nzt) *                                                   &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzt,nys:nyn,nxl:nxr), 3 ) )
+          w(nzt+1,nys:nyn,nxl:nxr) = w(nzt,nys:nyn,nxl:nxr)
+       ENDIF
+!
+!--    potential temperture
+       IF ( .NOT. neutral )  THEN
+          IF ( lod == 2 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   pt(nzt+1,j,i) = interpolate_in_time( nest_offl%pt_top(0,j,i),                   &
+                                                        nest_offl%pt_top(1,j,i),                   &
+                                                        fac_dt )
+                   pt_ref_l(nzt+1) = pt_ref_l(nzt+1) + pt(nzt+1,j,i)
+                ENDDO
+             ENDDO
+          ELSE
+             var_1d(nzt+1) = interpolate_in_time( nest_offl%pt_top(0,1,1),                         &
+                                                  nest_offl%pt_top(1,1,1),                         &
+                                                  fac_dt )
+             pt(nzt+1,nys:nyn,nxl:nxr) = var_1d(nzt+1)
+             pt_ref_l(nzt+1) = pt_ref_l(nzt+1) + SUM( pt(nzt+1,nys:nyn,nxl:nxr) )
+          ENDIF
+       ENDIF
+!
+!--    humidity
        IF ( humidity )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                q(nzt+1,j,i) = interpolate_in_time( nest_offl%q_top(0,j,i),    &
-                                                    nest_offl%q_top(1,j,i),    &
-                                                    fac_dt )
-                q_ref_l(nzt+1) = q_ref_l(nzt+1) + q(nzt+1,j,i)
-             ENDDO
-          ENDDO
+          IF ( lod == 2 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   q(nzt+1,j,i) = interpolate_in_time( nest_offl%q_top(0,j,i),                     &
+                                                       nest_offl%q_top(1,j,i),                     &
+                                                       fac_dt )
+                   q_ref_l(nzt+1) = q_ref_l(nzt+1) + q(nzt+1,j,i)
+                ENDDO
+             ENDDO
+          ELSE
+             var_1d(nzt+1) = interpolate_in_time( nest_offl%q_top(0,1,1),                          &
+                                                  nest_offl%q_top(1,1,1),                          &
+                                                  fac_dt )
+             q(nzt+1,nys:nyn,nxl:nxr) = var_1d(nzt+1)
+             q_ref_l(nzt+1) = q_ref_l(nzt+1) + SUM( q(nzt+1,nys:nyn,nxl:nxr) )
+          ENDIF
        ENDIF
 
@@ -1409,14 +2078,23 @@
           DO  n = 1, UBOUND( chem_species, 1 )
              IF ( nest_offl%chem_from_file_t(n) )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      chem_species(n)%conc(nzt+1,j,i) = interpolate_in_time(   &
-                                              nest_offl%chem_top(0,j,i,n),     &
-                                              nest_offl%chem_top(1,j,i,n),     &
-                                              fac_dt                       )
-                      ref_chem_l(nzt+1,n) = ref_chem_l(nzt+1,n) +              &
-                                            chem_species(n)%conc(nzt+1,j,i)
+                IF ( lod == 2 )  THEN
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         chem_species(n)%conc(nzt+1,j,i) = interpolate_in_time(                    &
+                                                 nest_offl%chem_top(0,j,i,n),                      &
+                                                 nest_offl%chem_top(1,j,i,n),                      &
+                                                 fac_dt                       )
+                         ref_chem_l(nzt+1,n) = ref_chem_l(nzt+1,n) +                               &
+                                               chem_species(n)%conc(nzt+1,j,i)
+                      ENDDO
                    ENDDO
-                ENDDO
+                ELSE
+                   var_1d(nzt+1) = interpolate_in_time( nest_offl%chem_top(0,1,1,n),               &
+                                                        nest_offl%chem_top(1,1,1,n),               &
+                                                        fac_dt )
+                   chem_species(n)%conc(nzt+1,nys:nyn,nxl:nxr) = var_1d(nzt+1)
+                   ref_chem_l(nzt+1,n) = ref_chem_l(nzt+1,n) +                                     &
+                                         SUM( chem_species(n)%conc(nzt+1,nys:nyn,nxl:nxr) )
+                ENDIF
              ENDIF
           ENDDO
@@ -1455,6 +2133,5 @@
 !--          Do local exchange only when necessary, i.e. when data is coming 
 !--          from dynamic file.
-             IF ( nest_offl%chem_from_file_t(n) )                              &
-                CALL exchange_horiz( chem_species(n)%conc, nbgp )
+             IF ( nest_offl%chem_from_file_t(n) )  CALL exchange_horiz( chem_species(n)%conc, nbgp )
           ENDDO
        ENDIF
@@ -1467,24 +2144,19 @@
        IF ( salsa )  CALL salsa_nesting_offl_bc
 !
-!--    In case of Rayleigh damping, where the profiles u_init, v_init
-!--    q_init and pt_init are still used, update these profiles from the
-!--    averaged boundary data. 
-!--    But first, average these data.
+!--    Calculate the mean profiles. These are later stored on u_init, v_init, 
+!--    etc., in order to adjust the Rayleigh damping under time-evolving atmospheric conditions
+!--    accordingly - damping against the representative mean profiles, not against the initial
+!--    profiles. Note, in LOD = 1 case no averaging is required.
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( u_ref_l, u_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM,     &
-                           comm2d, ierr )
-       CALL MPI_ALLREDUCE( v_ref_l, v_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM,     &
-                           comm2d, ierr )
+       CALL MPI_ALLREDUCE( u_ref_l, u_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
+       CALL MPI_ALLREDUCE( v_ref_l, v_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
        IF ( humidity )  THEN
-          CALL MPI_ALLREDUCE( q_ref_l, q_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM,  &
-                              comm2d, ierr )
+          CALL MPI_ALLREDUCE( q_ref_l, q_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
        IF ( .NOT. neutral )  THEN
-          CALL MPI_ALLREDUCE( pt_ref_l, pt_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM,&
-                              comm2d, ierr )
+          CALL MPI_ALLREDUCE( pt_ref_l, pt_ref, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
        IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          CALL MPI_ALLREDUCE( ref_chem_l, ref_chem,                            &
-                              ( nzt+1-nzb+1 ) * SIZE( ref_chem(nzb,:) ),       &
+          CALL MPI_ALLREDUCE( ref_chem_l, ref_chem, ( nzt+1-nzb+1 ) * SIZE( ref_chem(nzb,:) ),  &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
@@ -1501,33 +2173,22 @@
 !--    number of input data is different from nzb:nzt compared to nzt+1. 
 !--    Derived from lateral boundaries. 
-       u_ref(nzb:nzt) = u_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx     ),   &
-                                               KIND = wp )  
-       v_ref(nzb:nzt) = v_ref(nzb:nzt) / REAL( 2.0_wp * ( ny   + nx + 1   ),   &
-                                               KIND = wp )
-       IF ( humidity )                                                         &
-          q_ref(nzb:nzt) = q_ref(nzb:nzt)   / REAL( 2.0_wp *                   &
-                                                          ( ny + 1 + nx + 1 ), &
-                                                    KIND = wp )
-       IF ( .NOT. neutral )                                                    &
-          pt_ref(nzb:nzt) = pt_ref(nzb:nzt) / REAL( 2.0_wp *                   &
-                                                          ( ny + 1 + nx + 1 ), &
-                                              KIND = wp )
-       IF ( air_chemistry  .AND.  nesting_offline_chem )                       &
-          ref_chem(nzb:nzt,:) = ref_chem(nzb:nzt,:) / REAL( 2.0_wp *           &
-                                                          ( ny + 1 + nx + 1 ), &
-                                                            KIND = wp )
-!
-!--    Derived from top boundary.    
+       u_ref(nzb:nzt) = u_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx     ), KIND = wp )  
+       v_ref(nzb:nzt) = v_ref(nzb:nzt) / REAL( 2.0_wp * ( ny   + nx + 1   ), KIND = wp )
+       IF ( humidity )                                                                          &
+          q_ref(nzb:nzt) = q_ref(nzb:nzt)   / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+       IF ( .NOT. neutral )                                                                     &
+          pt_ref(nzb:nzt) = pt_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+       IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
+          ref_chem(nzb:nzt,:) = ref_chem(nzb:nzt,:) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+!
+!--    Derived from top boundary.
        u_ref(nzt+1) = u_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx     ), KIND = wp ) 
        v_ref(nzt+1) = v_ref(nzt+1) / REAL( ( ny     ) * ( nx + 1 ), KIND = wp )
-       IF ( humidity )                                                         &
-          q_ref(nzt+1) = q_ref(nzt+1)   / REAL( ( ny + 1 ) * ( nx + 1 ),       &
-                                                KIND = wp )
-       IF ( .NOT. neutral )                                                    &
-          pt_ref(nzt+1) = pt_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx + 1 ),       &
-                                                KIND = wp )
-       IF ( air_chemistry  .AND.  nesting_offline_chem )                       &
-          ref_chem(nzt+1,:) = ref_chem(nzt+1,:) /                              &
-                              REAL( ( ny + 1 ) * ( nx + 1 ),KIND = wp )
+       IF ( humidity )                                                                          &
+          q_ref(nzt+1) = q_ref(nzt+1)   / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
+       IF ( .NOT. neutral )                                                                     &
+          pt_ref(nzt+1) = pt_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
+       IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
+          ref_chem(nzt+1,:) = ref_chem(nzt+1,:) / REAL( ( ny + 1 ) * ( nx + 1 ),KIND = wp )
 !
 !--    Write onto init profiles, which are used for damping. Also set lower
@@ -1548,11 +2209,9 @@
           DO  n = 1, UBOUND( chem_species, 1 )
              IF ( nest_offl%chem_from_file_t(n) )  THEN 
-                chem_species(n)%conc_pr_init(:) = ref_chem(:,n)
-                chem_species(n)%conc_pr_init(nzb) =                            &
-                                            chem_species(n)%conc_pr_init(nzb+1)
+                chem_species(n)%conc_pr_init(:)   = ref_chem(:,n)
+                chem_species(n)%conc_pr_init(nzb) = chem_species(n)%conc_pr_init(nzb+1)
              ENDIF
           ENDDO
        ENDIF
-
        IF ( ALLOCATED( ref_chem   ) )  DEALLOCATE( ref_chem   )
        IF ( ALLOCATED( ref_chem_l ) )  DEALLOCATE( ref_chem_l )
@@ -1561,5 +2220,5 @@
 !--    Therefore, calculate boundary-layer depth first. 
        CALL nesting_offl_calc_zi
-       CALL adjust_sponge_layer 
+       CALL adjust_sponge_layer
 
        CALL  cpu_log( log_point(58), 'offline nesting', 'stop' )
@@ -1907,7 +2566,118 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_init
-           
-       INTEGER(iwp) ::  n !< running index for chemical species
-
+
+       INTEGER(iwp) ::  i   !< loop index for x-direction
+       INTEGER(iwp) ::  j   !< loop index for y-direction
+       INTEGER(iwp) ::  n   !< running index for chemical species
+
+!
+!--    Before arrays for the boundary data are allocated, the LOD of the dynamic input data
+!--    at the boundaries is read.
+#if defined ( __netcdf )
+!
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ), pids_id )
+!
+!--    Read attributes for LOD. In order to gurantee that also older drivers, where attribute is not given,
+!--    are working, do not abort the run but assume LOD2 forcing.
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_east_pt,  .FALSE., 'ls_forcing_left_pt', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_east_qv,  .FALSE., 'ls_forcing_left_qv', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_east_u,   .FALSE., 'ls_forcing_left_u',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_east_v,   .FALSE., 'ls_forcing_left_v',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_east_w,   .FALSE., 'ls_forcing_left_w',  .FALSE. )
+
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_north_pt, .FALSE., 'ls_forcing_north_pt', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_north_qv, .FALSE., 'ls_forcing_north_qv', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_north_u,  .FALSE., 'ls_forcing_north_u',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_north_v,  .FALSE., 'ls_forcing_north_v',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_north_w,  .FALSE., 'ls_forcing_north_w',  .FALSE. )
+
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_south_pt, .FALSE., 'ls_forcing_south_pt', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_south_qv, .FALSE., 'ls_forcing_south_qv', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_south_u,  .FALSE., 'ls_forcing_south_u',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_south_v,  .FALSE., 'ls_forcing_south_v',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_south_w,  .FALSE., 'ls_forcing_south_w',  .FALSE. )
+
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_west_pt,  .FALSE., 'ls_forcing_right_pt', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_west_qv,  .FALSE., 'ls_forcing_right_qv', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_west_u,   .FALSE., 'ls_forcing_right_u',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_west_v,   .FALSE., 'ls_forcing_right_v',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_west_w,   .FALSE., 'ls_forcing_right_w',  .FALSE. )
+
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_top_pt,   .FALSE., 'ls_forcing_top_pt', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_top_qv,   .FALSE., 'ls_forcing_top_qv', .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_top_u,    .FALSE., 'ls_forcing_top_u',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_top_v,    .FALSE., 'ls_forcing_top_v',  .FALSE. )
+       CALL get_attribute( pids_id, char_lod, nest_offl%lod_top_w,    .FALSE., 'ls_forcing_top_w',  .FALSE. )
+
+       CALL close_input_file( pids_id )
+#endif
+!
+!--    Temporary workaround until most of the dynamic drivers contain a LOD attribute. So far INIFOR
+!--    did not provide the LOD attribute. In order to still use these older dynamic drivers, provide
+!--    a temporary workaround. If the LOD is not given, a NetCDF interal error will occur but the simulation
+!--    will not be aborted since the no_abort flag is passed. However, the respective attribute value
+!--    might be given an arbitrary number. Hence, check for valid LOD's and manually set them to LOD 2 
+!--    (as assumed so far). Note, this workaround should be removed later (date of reference: 6. Oct. 2020).
+       IF ( nest_offl%lod_east_pt /= 1  .AND.  nest_offl%lod_east_pt /= 2 )  nest_offl%lod_east_pt = 2
+       IF ( nest_offl%lod_east_qv /= 1  .AND.  nest_offl%lod_east_qv /= 2 )  nest_offl%lod_east_qv = 2
+       IF ( nest_offl%lod_east_u  /= 1  .AND.  nest_offl%lod_east_u  /= 2 )  nest_offl%lod_east_u  = 2
+       IF ( nest_offl%lod_east_v  /= 1  .AND.  nest_offl%lod_east_v  /= 2 )  nest_offl%lod_east_v  = 2
+       IF ( nest_offl%lod_east_w  /= 1  .AND.  nest_offl%lod_east_w  /= 2 )  nest_offl%lod_east_w  = 2
+
+       IF ( nest_offl%lod_north_pt /= 1  .AND.  nest_offl%lod_north_pt /= 2 )  nest_offl%lod_north_pt = 2
+       IF ( nest_offl%lod_north_qv /= 1  .AND.  nest_offl%lod_north_qv /= 2 )  nest_offl%lod_north_qv = 2
+       IF ( nest_offl%lod_north_u  /= 1  .AND.  nest_offl%lod_north_u  /= 2 )  nest_offl%lod_north_u  = 2
+       IF ( nest_offl%lod_north_v  /= 1  .AND.  nest_offl%lod_north_v  /= 2 )  nest_offl%lod_north_v  = 2
+       IF ( nest_offl%lod_north_w  /= 1  .AND.  nest_offl%lod_north_w  /= 2 )  nest_offl%lod_north_w  = 2
+
+       IF ( nest_offl%lod_south_pt /= 1  .AND.  nest_offl%lod_south_pt /= 2 )  nest_offl%lod_south_pt = 2
+       IF ( nest_offl%lod_south_qv /= 1  .AND.  nest_offl%lod_south_qv /= 2 )  nest_offl%lod_south_qv = 2
+       IF ( nest_offl%lod_south_u  /= 1  .AND.  nest_offl%lod_south_u  /= 2 )  nest_offl%lod_south_u  = 2
+       IF ( nest_offl%lod_south_v  /= 1  .AND.  nest_offl%lod_south_v  /= 2 )  nest_offl%lod_south_v  = 2
+       IF ( nest_offl%lod_south_w  /= 1  .AND.  nest_offl%lod_south_w  /= 2 )  nest_offl%lod_south_w  = 2
+
+       IF ( nest_offl%lod_west_pt /= 1  .AND.  nest_offl%lod_west_pt /= 2 )  nest_offl%lod_west_pt = 2
+       IF ( nest_offl%lod_west_qv /= 1  .AND.  nest_offl%lod_west_qv /= 2 )  nest_offl%lod_west_qv = 2
+       IF ( nest_offl%lod_west_u  /= 1  .AND.  nest_offl%lod_west_u  /= 2 )  nest_offl%lod_west_u  = 2
+       IF ( nest_offl%lod_west_v  /= 1  .AND.  nest_offl%lod_west_v  /= 2 )  nest_offl%lod_west_v  = 2
+       IF ( nest_offl%lod_west_w  /= 1  .AND.  nest_offl%lod_west_w  /= 2 )  nest_offl%lod_west_w  = 2
+
+       IF ( nest_offl%lod_top_pt /= 1  .AND.  nest_offl%lod_top_pt /= 2 )  nest_offl%lod_top_pt = 2
+       IF ( nest_offl%lod_top_qv /= 1  .AND.  nest_offl%lod_top_qv /= 2 )  nest_offl%lod_top_qv = 2
+       IF ( nest_offl%lod_top_u  /= 1  .AND.  nest_offl%lod_top_u  /= 2 )  nest_offl%lod_top_u  = 2
+       IF ( nest_offl%lod_top_v  /= 1  .AND.  nest_offl%lod_top_v  /= 2 )  nest_offl%lod_top_v  = 2
+       IF ( nest_offl%lod_top_w  /= 1  .AND.  nest_offl%lod_top_w  /= 2 )  nest_offl%lod_top_w  = 2
+!
+!--    For consistency, check if all boundary input variables have the same LOD.
+       IF ( MAX( nest_offl%lod_east_pt,  nest_offl%lod_east_qv,  nest_offl%lod_east_u,             &
+                 nest_offl%lod_east_v,   nest_offl%lod_east_w,                                     &
+                 nest_offl%lod_north_pt, nest_offl%lod_north_qv, nest_offl%lod_north_u,            &
+                 nest_offl%lod_north_v,  nest_offl%lod_north_w,                                    &
+                 nest_offl%lod_south_pt, nest_offl%lod_south_qv, nest_offl%lod_south_u,            &
+                 nest_offl%lod_south_v,  nest_offl%lod_south_w,                                    &
+                 nest_offl%lod_north_pt, nest_offl%lod_north_qv, nest_offl%lod_north_u,            &
+                 nest_offl%lod_north_v,  nest_offl%lod_north_w,                                    &
+                 nest_offl%lod_top_pt,   nest_offl%lod_top_qv,   nest_offl%lod_top_u,              &
+                 nest_offl%lod_top_v,    nest_offl%lod_top_w )                                     &
+               /=                                                                                  &
+            MIN( nest_offl%lod_east_pt,  nest_offl%lod_east_qv,  nest_offl%lod_east_u,             &
+                 nest_offl%lod_east_v,   nest_offl%lod_east_w,                                     &
+                 nest_offl%lod_north_pt, nest_offl%lod_north_qv, nest_offl%lod_north_u,            &
+                 nest_offl%lod_north_v,  nest_offl%lod_north_w,                                    &
+                 nest_offl%lod_south_pt, nest_offl%lod_south_qv, nest_offl%lod_south_u,            &
+                 nest_offl%lod_south_v,  nest_offl%lod_south_w,                                    &
+                 nest_offl%lod_north_pt, nest_offl%lod_north_qv, nest_offl%lod_north_u,            &
+                 nest_offl%lod_north_v,  nest_offl%lod_north_w,                                    &
+                 nest_offl%lod_top_pt,   nest_offl%lod_top_qv,   nest_offl%lod_top_u,              &
+                 nest_offl%lod_top_v,    nest_offl%lod_top_w ) )  THEN
+          message_string = 'A mixture of different LOD for the provided boundary data is not ' //  &
+                           'possible.'
+          CALL message( 'nesting_offl_init', 'PA0504', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    As all LODs are the same, store it.
+       lod = nest_offl%lod_east_u
+!
 !--    Allocate arrays for geostrophic wind components. Arrays will 
 !--    incorporate 2 time levels in order to interpolate in between. 
@@ -1915,41 +2685,68 @@
        ALLOCATE( nest_offl%vg(0:1,1:nzt) )
 !
-!--    Allocate arrays for reading left/right boundary values. Arrays will 
-!--    incorporate 2  time levels in order to interpolate in between. If the core has 
-!--    no boundary, allocate a dummy array, in order to enable netcdf parallel
-!--    access. Dummy arrays will be allocated with dimension length zero.
+!--    Set index range according to the given LOD in order to allocate the input arrays
+       IF ( bc_dirichlet_l  .OR.  bc_dirichlet_r  )  THEN
+          IF ( lod == 2 )  THEN
+             j_start   = nys
+             j_start_v = nysv
+             j_end     = nyn
+          ELSE
+             j_start   = 1
+             j_start_v = 1
+             j_end     = 1
+          ENDIF
+       ENDIF
+
+       IF ( bc_dirichlet_n  .OR.  bc_dirichlet_s )  THEN
+          IF( lod == 2 )  THEN
+             i_start   = nxl
+             i_start_u = nxlu
+             i_end     = nxr
+          ELSE
+             i_start   = 1
+             i_start_u = 1
+             i_end     = 1
+          ENDIF
+       ENDIF
+!
+!--    Allocate arrays for reading left/right boundary values. Arrays will
+!--    incorporate 2 time levels in order to interpolate in between. Depending on the given LOD,
+!--    the x-, or y-dimension will be either nxl:nxr, or nys:nyn (for LOD=2), or it reduces to
+!--    one element for LOD=1. If the core has no lateral boundary, allocate a dummy array as well,
+!--    in order to enable netcdf parallel access. Dummy arrays will be allocated with dimension
+!--    length zero.
        IF ( bc_dirichlet_l )  THEN
-          ALLOCATE( nest_offl%u_left(0:1,nzb+1:nzt,nys:nyn)  )
-          ALLOCATE( nest_offl%v_left(0:1,nzb+1:nzt,nysv:nyn) )
-          ALLOCATE( nest_offl%w_left(0:1,nzb+1:nzt-1,nys:nyn) )
-          IF ( humidity )       ALLOCATE( nest_offl%q_left(0:1,nzb+1:nzt,nys:nyn)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_left(0:1,nzb+1:nzt,nys:nyn) )
+          ALLOCATE( nest_offl%u_l(0:1,nzb+1:nzt,j_start:j_end)  )
+          ALLOCATE( nest_offl%v_l(0:1,nzb+1:nzt,j_start_v:j_end) )
+          ALLOCATE( nest_offl%w_l(0:1,nzb+1:nzt-1,j_start:j_end) )
+          IF ( humidity )       ALLOCATE( nest_offl%q_l(0:1,nzb+1:nzt,j_start:j_end)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_l(0:1,nzb+1:nzt,j_start:j_end) )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_left(0:1,nzb+1:nzt,nys:nyn,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_l(0:1,nzb+1:nzt,j_start:j_end,1:UBOUND( chem_species, 1 )) )
        ELSE
-          ALLOCATE( nest_offl%u_left(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%v_left(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%w_left(1:1,1:1,1:1)  )
-          IF ( humidity )       ALLOCATE( nest_offl%q_left(1:1,1:1,1:1)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_left(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%u_l(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%v_l(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%w_l(1:1,1:1,1:1)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_l(1:1,1:1,1:1)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_l(1:1,1:1,1:1)  )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_left(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_l(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
        ENDIF
        IF ( bc_dirichlet_r )  THEN
-          ALLOCATE( nest_offl%u_right(0:1,nzb+1:nzt,nys:nyn)  )
-          ALLOCATE( nest_offl%v_right(0:1,nzb+1:nzt,nysv:nyn) )
-          ALLOCATE( nest_offl%w_right(0:1,nzb+1:nzt-1,nys:nyn) )
-          IF ( humidity )       ALLOCATE( nest_offl%q_right(0:1,nzb+1:nzt,nys:nyn)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_right(0:1,nzb+1:nzt,nys:nyn) )
+          ALLOCATE( nest_offl%u_r(0:1,nzb+1:nzt,j_start:j_end)  )
+          ALLOCATE( nest_offl%v_r(0:1,nzb+1:nzt,j_start_v:j_end) )
+          ALLOCATE( nest_offl%w_r(0:1,nzb+1:nzt-1,j_start:j_end) )
+          IF ( humidity )       ALLOCATE( nest_offl%q_r(0:1,nzb+1:nzt,j_start:j_end)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_r(0:1,nzb+1:nzt,j_start:j_end) )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_right(0:1,nzb+1:nzt,nys:nyn,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_r(0:1,nzb+1:nzt,j_start:j_end,1:UBOUND( chem_species, 1 )) )
        ELSE
-          ALLOCATE( nest_offl%u_right(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%v_right(1:1,1:1,1:1)  )
-          ALLOCATE( nest_offl%w_right(1:1,1:1,1:1)  )
-          IF ( humidity )       ALLOCATE( nest_offl%q_right(1:1,1:1,1:1)  )
-          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_right(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%u_r(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%v_r(1:1,1:1,1:1)  )
+          ALLOCATE( nest_offl%w_r(1:1,1:1,1:1)  )
+          IF ( humidity )       ALLOCATE( nest_offl%q_r(1:1,1:1,1:1)  )
+          IF ( .NOT. neutral )  ALLOCATE( nest_offl%pt_r(1:1,1:1,1:1)  )
           IF ( air_chemistry  .AND.  nesting_offline_chem )                                        &
-             ALLOCATE( nest_offl%chem_right(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
+             ALLOCATE( nest_offl%chem_r(1:1,1:1,1:1,1:UBOUND( chem_species, 1 )) )
        ENDIF
 !
